vec3 colorPM = pow2(colorP.rgb);
color.rgb = colorPM * pow(glColor.rgb, vec3(0.35));

#ifdef GBUFFERS_WATER
    translucentMultAlreadyCalculated = true;

	#ifdef GENERATED_NORMALS
		//noGeneratedNormals = true;
	#endif

    lmCoordM.y = min(lmCoord.y * 1.07, 1.0); // Iris/Sodium skylight inconsistency workaround

    #if WATER_QUALITY >= 2 || defined WATER_WAVES
        vec3 worldPos = playerPos + cameraPosition;
        vec2 waterPos = (floor(worldPos.xz * 16.0) + worldPos.y * 32.0) * 0.0005;
        vec2 wind = vec2(frameTimeCounter * 0.004, 0.0);
    #endif

    #if WATER_QUALITY >= 2 // Water Foam and Noise Coloring
        float sample = texture2D(noisetex, waterPos * 0.5 + wind).g;
        sample = sample - 0.5;
        sample *= 0.3;
        color.rgb = pow(color.rgb, vec3(1.0 + sample));

        float depthT = texelFetch(depthtex1, texelCoord, 0).r;
        vec3 screenPosT = vec3(screenCoord, depthT);
        #ifdef TAA
            vec3 viewPosT = ScreenToView(vec3(TAAJitter(screenPosT.xy, -0.5), screenPosT.z));
        #else
            vec3 viewPosT = ScreenToView(screenPosT);
        #endif
        float lViewPosT = length(viewPosT);

        float lViewPosDif = lViewPos - lViewPosT;

        float foamThreshold = pow2(dot(colorPM, colorPM));
              foamThreshold = min(foamThreshold * 1.4, 1.2);
        float foam = clamp((lViewPosDif + foamThreshold) / foamThreshold, 0.0, 1.0);
        color = mix(color, vec4(sqrt(color.rgb), 1.0), foam * foam * (0.5 + 0.5 * pow2(lmCoord.y)));

        //if (isEyeInWater == 0) color.a = mix(color.a, 1.0, 0.8 * GetWaterFog(lViewPosDif));
    #endif

    #ifdef WATER_WAVES
        /*vec3 normalMap = vec3(0.0, 0.0, 1.0);
        float dither2 = texture2D(noisetex, (worldPos.xz + worldPos.y) * 1.0).r;
        dither2 = fract(dither2 + 1.61803398875 * mod(float(frameCounter), 3600.0));
        normalMap.xy += vec2(dither2 - 0.5) * 0.1;*/

        vec3 normalMap = vec3(0.0, 0.0, 1.0);
        normalMap.xy += texture2D(noisetex, waterPos + wind * 0.5).rg - 0.5;
             waterPos *= 0.5;
        normalMap.xy -= texture2D(noisetex, waterPos - wind).rg - 0.5;
             waterPos *= 0.5;
        normalMap.xy -= texture2D(noisetex, waterPos + wind).rg - 0.5;

        normalMap.xy *= 0.03 * lmCoordM.y + 0.01;

        mat3 tbnMatrix = mat3(tangent.x, binormal.x, normal.x,
                              tangent.y, binormal.y, normal.y,
                              tangent.z, binormal.z, normal.z);

        vec3 minNormal = mix(normal, vec3(-1.0), pow2(1.0 - fresnel));
        normalM = clamp(normalize(normalMap * tbnMatrix), minNormal, vec3(1.0));

        /*vec2 coord = signMidCoordPos * 0.5 + 0.5;
        vec2 absMidCoordPos2 = absMidCoordPos * 2.0;
        vec2 midCoord = texCoord - absMidCoordPos * signMidCoordPos;
        vec2 minimumMidCoordPos = midCoord - absMidCoordPos;

        coord += normalMap.xy * (1.0 + 6.0 * fresnel);
            
        vec2 sampleCoord = fract(coord) * absMidCoordPos2 + minimumMidCoordPos;

        colorP = texture2D(texture, sampleCoord);
        colorPM = pow2(colorP.rgb);
        color.rgb = colorPM * pow(glColor.rgb, vec3(0.35));*/
    #endif

    // Blending 
    float fresnel2 = fresnel * fresnel;
    translucentMult = vec4(mix(normalize(glColor.rgb), vec3(1.0), fresnel2 * eyeBrightnessM), 1.0);
    translucentMult = mix(translucentMult, vec4(1.0), min1(lViewPos * TRANSLUCENT_BLEND_FALLOFF_MULT));
    color.a = mix(color.a, 1.0, fresnel2);

    // PBR
    smoothnessG = min(pow2(pow2(dot(colorP.rgb, colorP.rgb) * 0.4)), 1.0);
    highlightMult = 7.5 - 7.5 * fresnel;
#endif
